
let ( +& ) (x1, v1) (x2, v2) =
  (x1 +. x2, v1 +. v2)

let ( *< ) c (x, v) =
  (c *. x, c *. v)
  
let eom_euler h f (x, v) =
  (x, v) +& (h *< f (x, v))

let rec dump_euler h f (x0, v0) n idx =
  print_float x0;
  print_endline "";
  let (x1, v1) = (x0, v0) +& (h *< f (x0, v0)) in
  if (idx+1) >= n then ()
  else dump_euler h f (x1, v1) n (idx+1)

let tpi = 8. *. atan 1.
let f (x, v) = (v, -.(tpi*.tpi) *. x)
let () = dump_euler 0.0001 f (0., 1.) 10000 0
